/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * Supports the creation of {@link MgCoordinateSystem} objects based on
 * a OpenGIS Well-Known Text (WKT) definition of the coordinate
 * system. This class is the main entry point for accessing assorted classes
 * and functionalities of the Coordinate System API
 *
 */
 public class MgCoordinateSystemFactory extends MgGuardDisposable {
  private long swigCPtr;

  public MgCoordinateSystemFactory(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgCoordinateSystemFactoryToMgGuardDisposable(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgCoordinateSystemFactory(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgCoordinateSystemFactory obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Constructs an {@link MgCoordinateSystemFactory} object.
 *
 */
 public MgCoordinateSystemFactory() {
    this(MapGuideDesktopApiJNI.new_MgCoordinateSystemFactory(), true);
  }

  
/**
 * Creates an {@link MgCoordinateSystem} instance given a definition of
 * the coordinate system in OpenGIS Well-Known Text (WKT)
 *
 * @param  wkt (String/string)  A string defining the coordinate system  in OpenGIS WKT format.
 * @return  Returns an {@link MgCoordinateSystem} instance that corresponds to
 *  the specified WKT definition.
 */
 public MgCoordinateSystem create(String wkt) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_Create(swigCPtr, wkt);
    return (cPtr == 0) ? null : (MgCoordinateSystem)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Gets the coordinate system catalog
 *
 * @return  Returns the {@link MgCoordinateSystemCatalog}
 */
 public MgCoordinateSystemCatalog getCatalog() {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GetCatalog(swigCPtr);
    return (cPtr == 0) ? null : (MgCoordinateSystemCatalog)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Constructs a {@link MgCoordinateSystemTransform} that can be used to transform
 * coordinates from the source coordinate system to the target coordinate
 * system.
 *
 * @param  pSource ({@link MgCoordinateSystem})  The source coordinate system
 * @param  pTarget ({@link MgCoordinateSystem})  The target coordinate system
 * @return  The coordinate system transform that can be used to transform coordinates
 * @since  2.0 */
 public MgCoordinateSystemTransform getTransform(MgCoordinateSystem pSource, MgCoordinateSystem pTarget) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GetTransform(swigCPtr, MgCoordinateSystem.getCPtr(pSource), MgCoordinateSystem.getCPtr(pTarget));
    return (cPtr == 0) ? null : (MgCoordinateSystemTransform)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Creates a {@link MgCoordinateSystem} object from the specified CS-Map coordinate
 * system code
 *
 * @param  code (String/string)  The CS-Map coordinate system code
 * @return  The coordinate system
 */
 public MgCoordinateSystem createFromCode(String code) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_CreateFromCode(swigCPtr, code);
    return (cPtr == 0) ? null : (MgCoordinateSystem)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Gets the matching CS-Map coordinate system code based on the specified
 *
 * @param  wkt (String/string)  The coordinate system WKT string
 * @return  The CS-Map coordinate system code that corresponds to the specified WKT
 */
 public String convertWktToCoordinateSystemCode(String wkt) {
  { return MapGuideDesktopApiJNI.MgCoordinateSystemFactory_ConvertWktToCoordinateSystemCode(swigCPtr, wkt); }
}

  
/**
 * Gets the matching coordinate system WKT based on the specified CS-Map
 * coordinate system code
 *
 * @param  code (String/string)  The CS-Map coordinate system code
 * @return  The coordinate system WKT string that corresponds to the specified CS-Map
 */
 public String convertCoordinateSystemCodeToWkt(String code) {
  { return MapGuideDesktopApiJNI.MgCoordinateSystemFactory_ConvertCoordinateSystemCodeToWkt(swigCPtr, code); }
}

  
/**
 * Returns a list of the available coordinate system categories
 *
 * @return  A {@link MgStringCollection} containing the names of the available coordinate
 *  system categories
 */
 public MgStringCollection enumerateCategories() {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_EnumerateCategories(swigCPtr);
    return (cPtr == 0) ? null : (MgStringCollection)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Returns a {@link MgBatchPropertyCollection} containing the properties of each
 * coordinate system under the specified category
 *
 * @param  category (String/string)  The coordinate system category to enumerate
 * @return  A {@link MgBatchPropertyCollection} containing the properties of each coordinate system
 *  under the specified category
 */
 public MgBatchPropertyCollection enumerateCoordinateSystems(String category) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_EnumerateCoordinateSystems(swigCPtr, category);
    return (cPtr == 0) ? null : (MgBatchPropertyCollection)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Gets the matching coordinate system WKT based on the specified EPSG code
 *
 * @param  code  The EPSG code
 * @return  The coordinate system WKT string that corresponds to the specified EPSG code
 */
 public String convertEpsgCodeToWkt(int code) {
  { return MapGuideDesktopApiJNI.MgCoordinateSystemFactory_ConvertEpsgCodeToWkt(swigCPtr, code); }
}

  
/**
 * Gets the matching EPSG code based on the specified coordinate system WKT
 *
 * @param  wkt (String/string)
 * @return  The EPSG code that corresponds to the specified coordinate system WKT string
 */
 public int convertWktToEpsgCode(String wkt) {
    return MapGuideDesktopApiJNI.MgCoordinateSystemFactory_ConvertWktToEpsgCode(swigCPtr, wkt);
  }

  
/**
 * Gets name of the underlying coordinate system library
 *
 * @return  Returns the name of the underlying coordinate system library
 */
 public String getBaseLibrary() {
  { return MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GetBaseLibrary(swigCPtr); }
}

  
/**
 * Gets whether the specified coordinate system WKT string is a valid one
 *
 * @param  wkt (String/string)
 * @return  Returns <b>true</b> if the specified WKT is valid. Returns <b>false</b> otherwise
 */
 public boolean isValid(String wkt) {
    return MapGuideDesktopApiJNI.MgCoordinateSystemFactory_IsValid(swigCPtr, wkt);
  }

  
/**
 * Constructs a grid boundary object.
 *
 * @param  southwest  The coordinates of the the southwest corner of a rectangular region  which represents the grid region.  This point <b>MUST</b> indeed be  southwest of the coordinate provided by the <c>northeast</c> parameter.
 * @param  northeast  The coordinates of the the northeast corner of a rectangular region  which represents the grid region.  This point <b>MUST</b> indeed be  northeast of the coordinate provided by the <c>southwest</c> parameter.
 * @return  Returns the grid boundary in the form used by the grid/graticule
 *  sub-system.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemGridBoundary gridBoundary(MgCoordinate southwest, MgCoordinate northeast) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GridBoundary__SWIG_0(swigCPtr, MgCoordinate.getCPtr(southwest), MgCoordinate.getCPtr(northeast));
    return (cPtr == 0) ? null : (MgCoordinateSystemGridBoundary)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Constructs a grid boundary object.  Externally, grid objects are in
 * viewport coordinates and define the extents of the region within
 * which a grid is to be drawn.  Such objects are often simple
 * rectangles, but his is not a requirement.
 *
 * @param  boundary  The grid boundary in the form of a {@link MgPolygon} with no interior rings.
 * @return  Returns the boundary in the form used by the grid/graticule sub-system.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemGridBoundary gridBoundary(MgPolygon boundary) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GridBoundary__SWIG_1(swigCPtr, MgPolygon.getCPtr(boundary));
    return (cPtr == 0) ? null : (MgCoordinateSystemGridBoundary)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  public MgCoordinateSystemGridSpecification gridSpecification() {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GridSpecification__SWIG_0(swigCPtr);
    return (cPtr == 0) ? null : (MgCoordinateSystemGridSpecification)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Constructs a grid specification object with all specifications set to
 * the values indicated by the supplied parameters.
 *
 * @param  increment  The distance between grid lines of a grid or graticule.  This value is  used for both the easting and northing grid lines; and the value must  be in the units specified by the <c>unitCode</c> parameter.
 * @param  tickIncrement  The distance between tick marks of a grid or graticule.  This value is  used for both the easting and northing tick marks; and the value must  be in the units specified by the <c>unitCode</c> parameter.
 * @param  unitCode  One of the values defined by the {@link MgCoordinateSystemUnitCode} object  which indicates the units in which the <c>increment</c>,  <c>tickIncrement</c>, and <c>curvePrecision</c> parameters are  specified.
 * @param  curvePrecision  In the units indicated by the <c>unitCode</c> parameter, the  <b>desired</b> maximum distance between the true complex curve and  the multi-segment approximation of the complex curve of any grid or  graticule line generated using this specification.
 * @return  A fully initialized grid specification object.
 * @exception  std::bad_alloc
 */
 public MgCoordinateSystemGridSpecification gridSpecification(double increment, double tickIncrement, int unitCode, double curvePrecision) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GridSpecification__SWIG_1(swigCPtr, increment, tickIncrement, unitCode, curvePrecision);
    return (cPtr == 0) ? null : (MgCoordinateSystemGridSpecification)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Constructs a grid specification object with all specifications set to
 * the values indicated by the supplied parameters.
 *
 * @param  gridType  A value defined by the {@link MgCoordinateSystemGridSpecializationType} object  which indicates the Type of specialized grid desired.
 * @param  gridLevel  A value which indicates the density of the grid desired.  The exact  value of this parameter is dependent upon the value of the  <c>gridType</c> argument.  See Remarks below.
 * @return  Returns a fully initialized grid specification structure.
 * @exception  std::bad_alloc
 */
 public MgCoordinateSystemGridSpecification gridSpecification(int gridType, int gridLevel) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GridSpecification__SWIG_2(swigCPtr, gridType, gridLevel);
    return (cPtr == 0) ? null : (MgCoordinateSystemGridSpecification)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Manufactures generic grid object.  A generic grid is one which simply
 * draws isolines of one coordinate system (the Grid coordinate system)
 * into the drawing space of another (the frame system).
 *
 * @param  sGridCs  The coordinate system code name of the grid coordinate system.
 * @param  sFrameCs  The coordinate system code name of the frame coordinate system.
 * @param  bSetExceptionsOn  <c>true</c> indicates that exceptions are to be thrown on all  exceptional conditions.
 * @return  Returns a disposable pointer to the abstract interface class from which the
 *  generic grid object (and all other grid objects) derive.
 *  object derive.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemGridBase genericGrid(String sGridCs, String sFrameCs, boolean bSetExceptionsOn) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GenericGrid__SWIG_0(swigCPtr, sGridCs, sFrameCs, bSetExceptionsOn);
    return (cPtr == 0) ? null : (MgCoordinateSystemGridBase)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Manufactures generic grid object.  A generic grid is one which simply
 * draws isolines of one coordinate system (the Grid coordinate system)
 * into the drawing space of another (the frame system).
 *
 * @param  pGridCs  The grid coordinate system.
 * @param  pFrameCs  The frame coordinate system.
 * @param  bSetExceptionsOn  <c>true</c> indicates that exceptions are to be thrown on all  exceptional conditions.
 * @return  Returns a disposable pointer to the abstract interface class from which the
 *  generic grid object (and all other grid objects) derive.
 *  object derive.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemGridBase genericGrid(MgCoordinateSystem pGridCs, MgCoordinateSystem pFrameCs, boolean bSetExceptionsOn) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GenericGrid__SWIG_1(swigCPtr, MgCoordinateSystem.getCPtr(pGridCs), MgCoordinateSystem.getCPtr(pFrameCs), bSetExceptionsOn);
    return (cPtr == 0) ? null : (MgCoordinateSystemGridBase)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Manufactures an MGRS grid object.  The returned object is suitable only
 * for use in simple coordinate <-> MGRS string calculations.
 *
 * @param  dEquatorialRadius  Equatorial radius of the ellipsod upon which conversions to and from  MGRS strings are to be based.
 * @param  dEccentricity  Eccentricity of the ellipsod upon which conversions to and from  MGRS strings are to be based.
 * @param  nLetteringScheme  A value as defined in the {@link MgCoordinateSystemMgrsLetteringScheme}  object which specifies the lettering scheme to be used on MGRS  string conversions.
 * @param  bSetExceptionsOn  <c>true</c> indicates that exceptions are to be thrown on coordinate  conversions which fail for any reason.
 * @return  Returns a disposable pointer to an {@link MgCoordinateSystemMgrs}
 *  object which is suitable <b>only</b> for MGRS string conversions.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemMgrs getMgrs(double dEquatorialRadius, double dEccentricity, short nLetteringScheme, boolean bSetExceptionsOn) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GetMgrs(swigCPtr, dEquatorialRadius, dEccentricity, nLetteringScheme, bSetExceptionsOn);
    return (cPtr == 0) ? null : (MgCoordinateSystemMgrs)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Manufactures an MGRS grid object.  The returned object is suitable only
 * for use in simple coordinate <-> MGRS string calculations.
 *
 * @param  sEllipsoidCode  Dictionary code name of the ellipsoid upon which conversions to and from  MGRS strings are to be based.
 * @param  nLetteringScheme  A value as defined in the {@link MgCoordinateSystemMgrsLetteringScheme}  object which specifies the lettering scheme to be used on MGRS  string conversions.
 * @param  bSetExceptionsOn  <c>true</c> indicates that exceptions are to be thrown on coordinate  conversions which fail for any reason.
 * @return  Returns a disposable pointer to an {@link MgCoordinateSystemMgrs}
 *  object which is suitable <b>only</b> for MGRS string conversions.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemMgrs getMgrsEllipsoid(String sEllipsoidCode, short nLetteringScheme, boolean bSetExceptionsOn) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GetMgrsEllipsoid(swigCPtr, sEllipsoidCode, nLetteringScheme, bSetExceptionsOn);
    return (cPtr == 0) ? null : (MgCoordinateSystemMgrs)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Manufactures an MGRS grid object.  The returned object is suitable only
 * for use in simple coordinate <-> MGRS string calculations.
 *
 * @param  sDatumCode  Dictionary code name of the datum whose referenced ellipsoid is to be  used for all conversions to and from MGRS strings.
 * @param  nLetteringScheme  A value as defined in the {@link MgCoordinateSystemMgrsLetteringScheme}  object which specifies the lettering scheme to be used on MGRS  string conversions.
 * @param  bSetExceptionsOn  <c>true</c> indicates that exceptions are to be thrown on coordinate  conversions which fail for any reason.
 * @return  Returns a disposable pointer to an {@link MgCoordinateSystemMgrs}
 *  object which is suitable <b>only</b> for MGRS string conversions.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemMgrs getMgrsDatum(String sDatumCode, short nLetteringScheme, boolean bSetExceptionsOn) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_GetMgrsDatum(swigCPtr, sDatumCode, nLetteringScheme, bSetExceptionsOn);
    return (cPtr == 0) ? null : (MgCoordinateSystemMgrs)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Manufactures an MGRS grid object which is suitable for generating an
 * actual MGRS grid.
 *
 * @param  pFrameCs  The frame coordinate system.
 * @param  bUseFrameDatum  <c>true</c> causes the frame datum to be used for all geodetic calculations  neccessary to generate the grid; otherwise WGS84 is assumed.
 * @param  nLetteringScheme  A value as defined in the {@link MgCoordinateSystemMgrsLetteringScheme}  object which specifies the lettering scheme to be used on MGRS  string conversions.
 * @param  bSetExceptionsOn  <c>true</c> indicates that exceptions are to be thrown on coordinate  conversions which fail for any reason. This applies only to MGRS string  conversions.
 * @return  Returns a disposable pointer to the abstract interface class from which the
 *  MGRS grid object (and all other grid objects) derive.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemGridBase mgrsGrid(MgCoordinateSystem pFrameCs, boolean bUseFrameDatum, short nLetteringScheme, boolean bSetExceptionsOn) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_MgrsGrid__SWIG_0(swigCPtr, MgCoordinateSystem.getCPtr(pFrameCs), bUseFrameDatum, nLetteringScheme, bSetExceptionsOn);
    return (cPtr == 0) ? null : (MgCoordinateSystemGridBase)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Manufactures an MGRS grid object which is suitable for generating an
 * actual MGRS grid.
 *
 * @param  sFrameCs  The dictionary code name of the frame coordinate system.
 * @param  bUseFrameDatum  <c>true</c> causes the frame datum to be used for all geodetic calculations  neccessary to generate the grid; otherwise WGS84 is assumed.
 * @param  nLetteringScheme  A value as defined in the {@link MgCoordinateSystemMgrsLetteringScheme}  object which specifies the lettering scheme to be used on MGRS  string conversions.
 * @param  bSetExceptionsOn  <c>true</c> indicates that exceptions are to be thrown on coordinate  conversions which fail for any reason. This applies only to MGRS string  conversions.
 * @return  Returns a disposable pointer to the abstract interface class from which the
 *  MGRS grid object (and all other grid objects) derive.
 * @exception  MgOutOfMemoryException
 */
 public MgCoordinateSystemGridBase mgrsGrid(String sFrameCs, boolean bUseFrameDatum, short nLetteringScheme, boolean bSetExceptionsOn) {
    long cPtr = MapGuideDesktopApiJNI.MgCoordinateSystemFactory_MgrsGrid__SWIG_1(swigCPtr, sFrameCs, bUseFrameDatum, nLetteringScheme, bSetExceptionsOn);
    return (cPtr == 0) ? null : (MgCoordinateSystemGridBase)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

}
